Index: /LMDZ5/branches/testing/DefLists/config.def_LMDZ5_AGCM
===================================================================
--- /LMDZ5/branches/testing/DefLists/config.def_LMDZ5_AGCM	(revision 2541)
+++ /LMDZ5/branches/testing/DefLists/config.def_LMDZ5_AGCM	(revision 2542)
@@ -81,6 +81,6 @@
 ###  If aerosol offline : type of coupled aerosol =0 (pas d aerosol) =1 (sulphate only default) =2 => bc  only =3 => pom only =4 => seasalt only =5 => dust only =6 => all aerosol 
 flag_aerosol=6 
-# Use stratospheric aerosols (default no)
-flag_aerosol_strat=n
+# Use stratospheric aerosols (0, 1, 2 - default 0)
+flag_aerosol_strat=0
 ### bl95_b0 =    Parameter in CDNC-maer link (Boucher&Lohmann 1995)
 bl95_b0=1.7
Index: /LMDZ5/branches/testing/DefLists/traceur.def
===================================================================
--- /LMDZ5/branches/testing/DefLists/traceur.def	(revision 2541)
+++ /LMDZ5/branches/testing/DefLists/traceur.def	(revision 2542)
@@ -1,5 +1,7 @@
-4
+6
 14 14 H2Ov
 10 10 H2Ol
+10 10 H2Oi
+10 10 Aga
 10 10 RN
 10 10 PB
Index: /LMDZ5/branches/testing/libf/dynphy_lonlat/grid_atob_m.f90
===================================================================
--- /LMDZ5/branches/testing/libf/dynphy_lonlat/grid_atob_m.f90	(revision 2541)
+++ /LMDZ5/branches/testing/libf/dynphy_lonlat/grid_atob_m.f90	(revision 2542)
@@ -29,14 +29,16 @@
 ! Local variables:
   CHARACTER(LEN=256) :: modname="fine2coarse"
-  INTEGER :: mi, ni, ii, ji, mo, no, io, jo, nr(2), m1, n1, m2, n2, mx, my, nn
-  LOGICAL :: li, lo
-  REAL    :: inc
+  INTEGER :: mi, ni, ii, ji, mo, no, io, jo, nr(2), m1,m2, n1,n2, mx,my, nn, i,j
+  LOGICAL :: li, lo, first=.TRUE.
+  REAL    :: inc, cpa, spa, crlo(SIZE(x_i))
+  REAL, SAVE :: pi, hpi
   INTEGER, DIMENSION(SIZE(x_o),SIZE(y_o)) :: num_tot
   LOGICAL, DIMENSION(SIZE(x_o),SIZE(y_o)) :: found, mask
-  REAL,    DIMENSION(SIZE(x_o),SIZE(y_o)) :: dist
+  REAL,    DIMENSION(SIZE(x_i),SIZE(y_i)) :: dist
   REAL,    DIMENSION(SIZE(x_o))           :: a, b
   REAL,    DIMENSION(SIZE(y_o))           :: c, d
   REAL,    PARAMETER :: thresh=1.E-5
 !-------------------------------------------------------------------------------
+  IF(first) THEN; pi=4.0*ATAN(1.0); hpi=pi/2.0; first=.FALSE.; END IF
   mi=SIZE(x_i); ni=SIZE(y_i); mo=SIZE(x_o); no=SIZE(y_o)
   m1=m1; m2=mo; mx=mo; IF(PRESENT(msk)) mx=SIZE(msk,1)
@@ -91,5 +93,7 @@
       IF(found(io,jo)) CYCLE
 !      IF(prt_level>=1) PRINT*, "Problem: point out of domain (i,j)=", io,jo
-      CALL dist_sphe(x_o(io),y_o(jo),x_i,y_i,dist(:,:))
+      crlo(:)=COS(x_o(io)-x_i(:))     !--- COS of points 1 and 2 angle
+      cpa=COS(y_o(jo)); spa=SIN(y_o(jo))
+      DO j=1,ni; dist(:,j)=ACOS(spa*SIN(y_i(j))+cpa*COS(y_i(j))*crlo(:)); END DO
       nr=MINLOC(dist(:,:))!; IF(prt_level>=1) PRINT*, "Solution: ", nr
       inc=1.0; IF(li) inc=d_i(nr(1),nr(2))
@@ -252,39 +256,4 @@
 !-------------------------------------------------------------------------------
 
-
-!-------------------------------------------------------------------------------
-!
-SUBROUTINE dist_sphe(rf_lon,rf_lat,rlon,rlat,distance)
-!
-!-------------------------------------------------------------------------------
-! Author:  Laurent Li (december 30th 1996).
-! Purpose: Compute min. distance (along big circle) between 2 points in radians.
-!-------------------------------------------------------------------------------
-  IMPLICIT NONE
-!-------------------------------------------------------------------------------
-! Arguments:
-  REAL, INTENT(IN) :: rf_lon, rf_lat  !--- Reference point coordinates (radians)
-  REAL, INTENT(IN) :: rlon(:), rlat(:)!--- Points longitudes/latitudes (radians)
-  REAL, INTENT(OUT):: distance(SIZE(rlon),SIZE(rlat)) !--- Distance    (radians)
-!-------------------------------------------------------------------------------
-! Local variables:
-  LOGICAL, SAVE :: first=.TRUE.
-  REAL,    SAVE :: pi, hpi
-  REAL    :: pa, pb, cpa, spa, crlo(SIZE(rlon))
-  INTEGER :: i, j
-!-------------------------------------------------------------------------------
-  IF(first) THEN; pi=4.0*ATAN(1.0); hpi=pi/2.0; first=.FALSE.; END IF
-  crlo(:)=COS(rf_lon-rlon(:))         !--- COS of points 1 and 2 angle
-  pa=hpi-rf_lat                       !--- North Pole - Point 1 distance
-  cpa=COS(pa); spa=SIN(pa)
-  DO j=1,SIZE(rlat)
-    pb=hpi-rlat(j)                    !--- North Pole - Point 2 distance
-    distance(:,j)=ACOS(cpa*COS(pb)+spa*SIN(pb)*crlo(:))
-  END DO
-
-END SUBROUTINE dist_sphe
-!
-!-------------------------------------------------------------------------------
-
 END MODULE grid_atob_m
 !
Index: /LMDZ5/branches/testing/libf/dynphy_lonlat/phylmd/etat0phys_netcdf.F90
===================================================================
--- /LMDZ5/branches/testing/libf/dynphy_lonlat/phylmd/etat0phys_netcdf.F90	(revision 2541)
+++ /LMDZ5/branches/testing/libf/dynphy_lonlat/phylmd/etat0phys_netcdf.F90	(revision 2542)
@@ -111,5 +111,5 @@
   LOGICAL :: ok_ade, ok_aie, ok_cdnc, aerosol_couple
   INTEGER :: flag_aerosol
-  LOGICAL :: flag_aerosol_strat
+  INTEGER :: flag_aerosol_strat
   LOGICAL :: new_aod
   REAL    :: bl95_b0, bl95_b1
Index: /LMDZ5/branches/testing/libf/dynphy_lonlat/phylmd/limit_netcdf.F90
===================================================================
--- /LMDZ5/branches/testing/libf/dynphy_lonlat/phylmd/limit_netcdf.F90	(revision 2541)
+++ /LMDZ5/branches/testing/libf/dynphy_lonlat/phylmd/limit_netcdf.F90	(revision 2542)
@@ -60,4 +60,5 @@
 !  *    11/2009: L. Guez     (ozone day & night climatos, see etat0_netcdf.F90)
 !  *    12/2009: D. Cugnet   (f77->f90, calendars, files from coupled runs)
+!  *    04/2016: D. Cugnet   (12/14 recs SST/SIC files: cyclic/interannual runs)
 !-------------------------------------------------------------------------------
 #ifndef CPP_1D
@@ -339,7 +340,7 @@
   INTEGER           :: ndays_in           ! number of days
 !--- misc
-  INTEGER           :: i, j, k, l         ! loop counters
+  INTEGER           :: i, j, k, l, ll     ! loop counters
   REAL, ALLOCATABLE :: work(:,:)          ! used for extrapolation
-  CHARACTER(LEN=25) :: title              ! for messages
+  CHARACTER(LEN=128):: title, mess        ! for messages
   LOGICAL           :: extrp              ! flag for extrapolation
   REAL              :: chmin, chmax
@@ -392,5 +393,5 @@
 !--- Time (variable is not needed - it is rebuilt - but calendar is)
   CALL ncerr(NF90_INQUIRE_DIMENSION(ncid, dids(3), name=dnam, len=lmdep), fnam)
-  ALLOCATE(timeyear(lmdep))
+  ALLOCATE(timeyear(MAX(lmdep,14)))
   CALL ncerr(NF90_INQ_VARID(ncid, dnam, varid), fnam)
   cal_in=' '
@@ -405,16 +406,25 @@
   CALL msg(5,'var, calendar, dim: '//TRIM(dnam)//' '//TRIM(cal_in), lmdep)
   
-!--- CONSTRUCTING THE INPUT TIME VECTOR FOR INTERPOLATION --------------------
-  !--- Determining input file number of days, depending on calendar
+!--- Determining input file number of days, depending on calendar
   ndays_in=year_len(anneeref, cal_in)
 
-!--- Time vector reconstruction (time vector from file is not trusted)
-!--- If input records are not monthly, time sampling has to be constant !
-  timeyear=mid_months(anneeref, cal_in, lmdep)
-  IF (lmdep /= 12) WRITE(lunout,*) 'Note : les fichiers de ', TRIM(mode), &
-       ' ne comportent pas 12, mais ', lmdep, ' enregistrements.'
+!--- Rebuilding input time vector (field from input file might be unreliable)
+  IF(lmdep==12) THEN
+    timeyear=mid_month(anneeref, cal_in, ndays_in)
+    CALL msg(0,'Monthly periodic input file (perpetual run).')
+  ELSE IF(lmdep==14) THEN
+    timeyear=mid_month(anneeref, cal_in, ndays_in)
+    CALL msg(0,'Monthly 14-records input file (interannual run).')
+  ELSE IF(lmdep==ndays_in) THEN
+    timeyear=[(REAL(k)-0.5,k=1,ndays_in)]
+    CALL msg(0,'Daily input file (no time interpolation).')
+  ELSE
+    WRITE(mess,'(a,i3,a,i3,a)')'Mismatching input file: found',lmdep,        &
+      ' records, 12/14/',ndays_in,' (periodic/interannual/daily) needed'
+    CALL abort_physic('mid_months',TRIM(mess),1)
+  END IF
 
 !--- GETTING THE FIELD AND INTERPOLATING IT ----------------------------------
-  ALLOCATE(champ(imdep, jmdep), champtime(iim, jjp1, lmdep))
+  ALLOCATE(champ(imdep, jmdep), champtime(iim, jjp1, MAX(lmdep,14)))
   IF(extrp) ALLOCATE(work(imdep, jmdep))
   CALL msg(5,'')
@@ -436,6 +446,12 @@
       WHERE(NINT(mask)/=1) champint=0.001
     END IF
-    champtime(:, :, l)=champint
+    !--- Special case for periodic input file: index shifted
+    ll = l; IF(lmdep==12) ll = l + 1
+    champtime(:, :, ll)=champint
   END DO
+  IF(lmdep==12) THEN
+    champtime(:,:, 1)=champtime(:,:,13)
+    champtime(:,:,14)=champtime(:,:, 2)
+  END IF
   CALL ncerr(NF90_CLOSE(ncid), fnam)
 
@@ -444,27 +460,39 @@
 
 !--- TIME INTERPOLATION ------------------------------------------------------
-  IF(prt_level>5) THEN
-     WRITE(lunout, *)
-     WRITE(lunout, *)'INTERPOLATION TEMPORELLE.'
-     WRITE(lunout, *)' Vecteur temps en entree: ', timeyear
-     WRITE(lunout, *)' Vecteur temps en sortie de 0 a ', ndays
-  END IF
-
-  ALLOCATE(yder(lmdep), champan(iip1, jjp1, ndays))
-  skip = .false.
-  n_extrap = 0
-  DO j=1, jjp1
-    DO i=1, iim
-      yder = pchsp_95(timeyear, champtime(i, j, :), ibeg=2, iend=2, &
-           vc_beg=0., vc_end=0.)
-      CALL pchfe_95(timeyear, champtime(i, j, :), yder, skip, &
-           arth(0., real(ndays_in) / ndays, ndays), champan(i, j, :), ierr)
-      if (ierr < 0) stop 1
-      n_extrap = n_extrap + ierr
-    END DO
-  END DO
-  if (n_extrap /= 0) then
-     WRITE(lunout,*) "get_2Dfield pchfe_95: n_extrap = ", n_extrap
-  end if
+  IF(prt_level>0) THEN
+     IF(ndays/=ndays_in) THEN
+        WRITE(lunout, *)
+        WRITE(lunout,*)'DIFFERENTES LONGEURS D ANNEES:'
+        WRITE(lunout,*)' Dans le fichier d entree: ',ndays_in
+        WRITE(lunout,*)' Dans le fichier de sortie: ',ndays
+     END IF
+     IF(lmdep==ndays_in) THEN
+        WRITE(lunout, *)
+        WRITE(lunout, *)'PAS D INTERPOLATION TEMPORELLE.'
+        WRITE(lunout, *)' Fichier journalier en entree.'
+     ELSE
+        WRITE(lunout, *)'INTERPOLATION TEMPORELLE.'
+        WRITE(lunout, *)' Vecteur temps en entree: ', timeyear
+        WRITE(lunout, *)' Vecteur temps en sortie de 0 a ', ndays-1
+     END IF
+  END IF
+  ALLOCATE(yder(MAX(lmdep,14)), champan(iip1, jjp1, ndays))
+  IF(lmdep==ndays_in) THEN
+     champan(1:iim,:,:)=champtime
+  ELSE
+     skip = .false.
+     n_extrap = 0
+     DO j=1, jjp1
+       DO i=1, iim
+         yder = pchsp_95(timeyear, champtime(i, j, :), ibeg=2, iend=2, &
+              vc_beg=0., vc_end=0.)
+         CALL pchfe_95(timeyear, champtime(i, j, :), yder, skip, &
+              arth(0., real(ndays_in) / ndays, ndays), champan(i, j, :), ierr)
+         if (ierr < 0) stop 1
+         n_extrap = n_extrap + ierr
+       END DO
+     END DO
+     IF(n_extrap /= 0) WRITE(lunout,*) "get_2Dfield pchfe_95: n_extrap = ", n_extrap
+  END IF
   champan(iip1, :, :)=champan(1, :, :)
   DEALLOCATE(yder, champtime, timeyear)
@@ -752,5 +780,5 @@
 !-------------------------------------------------------------------------------
 !
-FUNCTION mid_months(y,cal_in,nm)
+FUNCTION mid_month(y,cal_in,ndays_out)
 !
 !-------------------------------------------------------------------------------
@@ -758,48 +786,35 @@
 !-------------------------------------------------------------------------------
 ! Arguments:
-  INTEGER,                INTENT(IN) :: y               ! year
-  CHARACTER(LEN=*),       INTENT(IN) :: cal_in          ! calendar
-  INTEGER,                INTENT(IN) :: nm              ! months/year number
-  REAL,    DIMENSION(nm)             :: mid_months      ! mid-month times
+  INTEGER,          INTENT(IN) :: y           ! year
+  CHARACTER(LEN=*), INTENT(IN) :: cal_in      ! calendar
+  INTEGER,          INTENT(IN) :: ndays_out   ! days   number
+  REAL,          DIMENSION(14) :: mid_month   ! mid-bins times
 !-------------------------------------------------------------------------------
 ! Local variables:
-  CHARACTER(LEN=99)                  :: mess            ! error message
-  CHARACTER(LEN=20)                  :: cal_out         ! calendar (for outputs)
-  INTEGER, DIMENSION(nm)             :: mnth            ! months lengths (days)
-  INTEGER                            :: m               ! months counter
-  INTEGER                            :: nd              ! number of days
-!-------------------------------------------------------------------------------
-  nd=year_len(y,cal_in)
-
-  IF(nm==12) THEN
-
-  !--- Getting the input calendar to reset at the end of the function
-    CALL ioget_calendar(cal_out)
-
-  !--- Unlocking calendar and setting it to wanted one
-    CALL lock_calendar(.FALSE.); CALL ioconf_calendar(TRIM(cal_in))
-
-  !--- Getting the length of each month
-    DO m=1,nm; mnth(m)=ioget_mon_len(y,m); END DO
+  CHARACTER(LEN=99)      :: mess              ! error message
+  CHARACTER(LEN=20)      :: cal_out           ! output calendar
+  INTEGER, DIMENSION(14) :: tlen              ! months lengths (days)
+  INTEGER                :: m                 ! months counter
+  INTEGER                :: nd                ! number of days
+!-------------------------------------------------------------------------------
+  !--- Save the input calendar to reset it at the end of the function
+  CALL ioget_calendar(cal_out)
+
+  !--- Unlock calendar and set it to "cal_in"
+  CALL lock_calendar(.FALSE.); CALL ioconf_calendar(TRIM(cal_in))
+
+  !--- Get the length of each month
+  tlen(1 )=ioget_mon_len(y-1,12)
+  DO m=1,12; tlen(m+1)=ioget_mon_len(y,m); END DO
+  tlen(14)=ioget_mon_len(y+1, 1)
+
+  !--- Mid-bins times
+  mid_month(1)=-0.5*REAL(tlen(1))
+  DO m=2,14; mid_month(m)=mid_month(m-1)+0.5*REAL(tlen(m-1)+tlen(m)); END DO
 
   !--- Back to original calendar
-    CALL lock_calendar(.FALSE.); CALL ioconf_calendar(TRIM(cal_out))
-
-  ELSE IF(MODULO(nd,nm)/=0) THEN
-    WRITE(mess,'(a,i3,a,i3,a)')'Unconsistent calendar: ',nd,' days/year, but ',&
-      nm,' months/year. Months number should divide days number.'
-    CALL abort_physic('mid_months',TRIM(mess),1)
-
-  ELSE
-    mnth=[(m,m=1,nm,nd/nm)]
-  END IF
-
-!--- Mid-months times
-  mid_months(1)=0.5*REAL(mnth(1))
-  DO k=2,nm
-    mid_months(k)=mid_months(k-1)+0.5*REAL(mnth(k-1)+mnth(k))
-  END DO
-
-END FUNCTION mid_months
+  CALL lock_calendar(.FALSE.); CALL ioconf_calendar(TRIM(cal_out))
+
+END FUNCTION mid_month
 !
 !-------------------------------------------------------------------------------
@@ -863,2 +878,3 @@
 !
 !*******************************************************************************
+
Index: /LMDZ5/branches/testing/libf/misc/wxios.F90
===================================================================
--- /LMDZ5/branches/testing/libf/misc/wxios.F90	(revision 2541)
+++ /LMDZ5/branches/testing/libf/misc/wxios.F90	(revision 2542)
@@ -1,3 +1,3 @@
-! $Id: wxios.F90 $
+! $Id$
 #ifdef CPP_XIOS
 MODULE wxios
@@ -33,5 +33,9 @@
     SUBROUTINE reformadate(odate, ndate)
         CHARACTER(len=*), INTENT(IN) :: odate
+#ifdef XIOS1
         CHARACTER(len=100), INTENT(OUT) :: ndate
+#else
+        TYPE(xios_duration) :: ndate
+#endif
         
         INTEGER :: i = 0
@@ -48,15 +52,27 @@
         i = INDEX(odate, "day")
         IF (i > 0) THEN
+#ifdef XIOS1
             ndate = odate(1:i-1)//"d"
+#else
+            read(odate(1:i-1),*) ndate%day
+#endif
         END IF
 
         i = INDEX(odate, "hr")
         IF (i > 0) THEN
+#ifdef XIOS1
             ndate = odate(1:i-1)//"h"
+#else
+            read(odate(1:i-1),*) ndate%hour
+#endif
         END IF
 
         i = INDEX(odate, "mth")
         IF (i > 0) THEN
+#ifdef XIOS1
             ndate = odate(1:i-1)//"mo"
+#else
+            read(odate(1:i-1),*) ndate%month
+#endif
         END IF
         
@@ -99,6 +115,6 @@
 
     SUBROUTINE wxios_init(xios_ctx_name, locom, outcom, type_ocean)
-        IMPLICIT NONE
-        INCLUDE 'iniprint.h'
+        USE print_control_mod, ONLY : prt_level, lunout
+        IMPLICIT NONE
 
       CHARACTER(len=*), INTENT(IN) :: xios_ctx_name
@@ -140,9 +156,11 @@
 
     SUBROUTINE wxios_context_init()
-        IMPLICIT NONE
-        INCLUDE 'iniprint.h'
+        USE print_control_mod, ONLY : prt_level, lunout
+!        USE mod_phys_lmdz_mpi_data, ONLY : COMM_LMDZ_PHY
+        IMPLICIT NONE
 
         TYPE(xios_context) :: xios_ctx
 
+!$OMP MASTER
         !Initialisation du contexte:
         CALL xios_context_initialize(g_ctx_name, g_comm)
@@ -157,4 +175,5 @@
         !Une première analyse des héritages:
         CALL xios_solve_inheritance()
+!$OMP END MASTER
     END SUBROUTINE wxios_context_init
 
@@ -164,6 +183,6 @@
 
     SUBROUTINE wxios_set_cal(pasdetemps, calendrier, annee, mois, jour, heure, ini_an, ini_mois, ini_jour, ini_heure)
-        IMPLICIT NONE
-        INCLUDE 'iniprint.h'
+        USE print_control_mod, ONLY : prt_level, lunout
+        IMPLICIT NONE
 
      !Paramètres:
@@ -178,10 +197,19 @@
      
      !Variables pour xios:
+#ifdef XIOS1
      TYPE(xios_time) :: mdtime
+#else
+     TYPE(xios_duration) :: mdtime
+#endif
      !REAL(kind = 8) :: year=0, month=0, day=0, hour=0, minute=0, second=0
      
+#ifdef XIOS1
         mdtime = xios_time(0, 0, 0, 0, 0, pasdetemps)
+#else
+        mdtime%second=pasdetemps
+#endif
 
         !Réglage du calendrier:
+#ifdef XIOS1
         SELECT CASE (calendrier)
             CASE('earth_360d')
@@ -198,11 +226,30 @@
                 CALL abort_gcm('Gcm:Xios',abort_message,1)
         END SELECT
+#else
+        SELECT CASE (calendrier)
+            CASE('earth_360d')
+                CALL xios_define_calendar("D360")
+                IF (prt_level >= 10) WRITE(lunout,*) 'wxios_set_cal: Calendrier terrestre a 360 jours/an'
+            CASE('earth_365d')
+                CALL xios_define_calendar("NoLeap")
+                IF (prt_level >= 10) WRITE(lunout,*) 'wxios_set_cal: Calendrier terrestre a 365 jours/an'
+            CASE('gregorian')
+                CALL xios_define_calendar("Gregorian")
+                IF (prt_level >= 10) WRITE(lunout,*) 'wxios_set_cal: Calendrier gregorien'
+            CASE DEFAULT
+                abort_message = 'wxios_set_cal: Mauvais choix de calendrier'
+                CALL abort_gcm('Gcm:Xios',abort_message,1)
+        END SELECT
+#endif
         
         !Formatage de la date d'origine:
-        WRITE(date, "(i4.4,'-',i2.2,'-',i2.2,' ',i2.2,':00:00')") annee, mois, jour, int(heure)
+        WRITE(date, "(i4.4,'-',i2.2,'-',i2.2,' ',i2.2,':00:00')") annee, mois, jour, int(heure) 
         
         IF (prt_level >= 10) WRITE(lunout,*) "wxios_set_cal: Time origin: ", date
-        
+#ifdef XIOS1
         CALL xios_set_context_attr_hdl(g_ctx, time_origin = date)
+#else
+        CALL xios_set_time_origin(xios_date(annee,mois,jour,int(heure),0,0))
+#endif
 
         !Formatage de la date de debut:
@@ -212,5 +259,9 @@
         IF (prt_level >= 10) WRITE(lunout,*) "wxios_set_cal: Start date: ", date
         
+#ifdef XIOS1
         CALL xios_set_context_attr_hdl(g_ctx, start_date = date)
+#else
+        CALL xios_set_start_date(xios_date(ini_an,ini_mois,ini_jour,int(ini_heure),0,0))
+#endif
         
         !Et enfin,le pas de temps:
@@ -221,7 +272,13 @@
     SUBROUTINE wxios_set_timestep(ts)
         REAL, INTENT(IN) :: ts
+#ifdef XIOS1
         TYPE(xios_time) :: mdtime     
 
         mdtime = xios_time(0, 0, 0, 0, 0, ts)
+#else
+        TYPE(xios_duration) :: mdtime     
+
+        mdtime%timestep = ts
+#endif
 
         CALL xios_set_timestep(mdtime)
@@ -237,6 +294,6 @@
          
 
-        IMPLICIT NONE
-        INCLUDE 'iniprint.h'
+        USE print_control_mod, ONLY : prt_level, lunout
+        IMPLICIT NONE
 
         CHARACTER(len=*),INTENT(IN) :: dom_id ! domain identifier
@@ -277,8 +334,13 @@
         
         !On parametrise le domaine:
+#ifdef XIOS1
         CALL xios_set_domain_attr_hdl(dom, ni_glo=ni_glo, ibegin=ibegin, ni=ni)
         CALL xios_set_domain_attr_hdl(dom, nj_glo=nj_glo, jbegin=jbegin, nj=nj, data_dim=2)
         CALL xios_set_domain_attr_hdl(dom, lonvalue=io_lon(ibegin:iend), latvalue=io_lat(jbegin:jend))
-
+#else
+        CALL xios_set_domain_attr_hdl(dom, ni_glo=ni_glo, ibegin=ibegin-1, ni=ni, type="rectilinear")
+        CALL xios_set_domain_attr_hdl(dom, nj_glo=nj_glo, jbegin=jbegin-1, nj=nj, data_dim=2)
+        CALL xios_set_domain_attr_hdl(dom, lonvalue_1d=io_lon(ibegin:iend), latvalue_1d=io_lat(jbegin:jend))
+#endif
         IF (.NOT.is_sequential) THEN
             mask(:,:)=.TRUE.
@@ -291,5 +353,9 @@
               WRITE(lunout,*) "wxios_domain_param: mpirank=",mpi_rank," mask(:,nj)=",mask(:,nj)
             ENDIF
+#ifdef XIOS1
             CALL xios_set_domain_attr_hdl(dom, mask=mask)
+#else
+            CALL xios_set_domain_attr_hdl(dom, mask_2d=mask)
+#endif
         END IF
 
@@ -307,6 +373,6 @@
     !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
     SUBROUTINE wxios_add_vaxis(axis_id, axis_size, axis_value)
-        IMPLICIT NONE
-        INCLUDE 'iniprint.h'
+        USE print_control_mod, ONLY : prt_level, lunout
+        IMPLICIT NONE
 
         CHARACTER (len=*), INTENT(IN) :: axis_id
@@ -335,6 +401,9 @@
         
         ! Ehouarn: New way to declare axis, without axis_group:
+#ifdef XIOS1
         CALL xios_set_axis_attr(trim(axis_id),size=axis_size,value=axis_value)
-        
+#else
+        CALL xios_set_axis_attr(trim(axis_id),n_glo=axis_size,value=axis_value)
+#endif        
         !Vérification:
         IF (xios_is_valid_axis(TRIM(ADJUSTL(axis_id)))) THEN
@@ -351,6 +420,6 @@
     !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
     SUBROUTINE wxios_add_file(fname, ffreq, flvl)
-        IMPLICIT NONE
-        INCLUDE 'iniprint.h'
+        USE print_control_mod, ONLY : prt_level, lunout
+        IMPLICIT NONE
 
         CHARACTER(len=*), INTENT(IN) :: fname
@@ -360,5 +429,9 @@
         TYPE(xios_file) :: x_file
         TYPE(xios_filegroup) :: x_fg
+#ifdef XIOS1
         CHARACTER(len=100) :: nffreq
+#else
+        TYPE(xios_duration) :: nffreq
+#endif
         
         !On regarde si le fichier n'est pas défini par XML:
@@ -372,15 +445,28 @@
         
             !On configure:
+#ifdef XIOS1
             CALL xios_set_file_attr_hdl(x_file, name="X"//fname,&
                 output_freq=TRIM(ADJUSTL(nffreq)), output_level=flvl, enabled=.TRUE.)
-        
+#else
+            CALL xios_set_file_attr_hdl(x_file, name="X"//fname,&
+                output_freq=nffreq, output_level=flvl, enabled=.TRUE.)
+#endif
+       
             IF (xios_is_valid_file("X"//fname)) THEN
                 IF (prt_level >= 10) THEN
                   WRITE(lunout,*) "wxios_add_file: New file: ", "X"//fname
+#ifdef XIOS1
                   WRITE(lunout,*) "wxios_add_file: output_freq=",TRIM(ADJUSTL(nffreq)),"; output_lvl=",flvl
+#else
+                  WRITE(lunout,*) "wxios_add_file: output_freq=",nffreq,"; output_lvl=",flvl
+#endif
                 ENDIF
             ELSE
                 WRITE(lunout,*) "wxios_add_file: Error, invalid file: ", "X"//trim(fname)
+#ifdef XIOS1
                 WRITE(lunout,*) "wxios_add_file: output_freq=",TRIM(ADJUSTL(nffreq)),"; output_lvl=",flvl
+#else
+                WRITE(lunout,*) "wxios_add_file: output_freq=",nffreq,"; output_lvl=",flvl
+#endif
             END IF
         ELSE
@@ -435,6 +521,6 @@
     !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
     SUBROUTINE wxios_add_field_to_file(fieldname, fdim, fid, fname, fieldlongname, fieldunit, field_level, op, nam_axvert)
-        IMPLICIT NONE
-        INCLUDE 'iniprint.h'
+        USE print_control_mod, ONLY : prt_level, lunout
+        IMPLICIT NONE
 
         CHARACTER(len=*), INTENT(IN) :: fieldname
@@ -452,4 +538,7 @@
         TYPE(xios_field) :: field
         TYPE(xios_fieldgroup) :: fieldgroup
+#ifndef XIOS1
+        TYPE(xios_duration) :: freq_op
+#endif
         LOGICAL :: bool=.FALSE.
         INTEGER :: lvl =0
@@ -510,5 +599,10 @@
             
             !L'operation, sa frequence:
+#ifdef XIOS1
             CALL xios_set_field_attr_hdl(field, field_ref=fieldname, operation=TRIM(ADJUSTL(operation)), freq_op="1ts", prec=4)
+#else
+            freq_op%timestep=1
+            CALL xios_set_field_attr_hdl(field, field_ref=fieldname, operation=TRIM(ADJUSTL(operation)), freq_op=freq_op, prec=4)
+#endif
 
             
